const invitationHelper = require('./Invitation')
const mailService = require('pubsweet-component-mail-service')
const logger = require('@pubsweet/logger')

module.exports = {
  addInvitation: async (collection, userId, role) => {
    collection.invitations = collection.invitations || []
    const matchingInvitation = collection.invitations.find(
      invitation =>
        invitation.userId === userId &&
        invitation.role === role &&
        invitation.hasAnswer === false,
    )
    if (matchingInvitation === undefined) {
      collection = await invitationHelper.setupInvitation(
        userId,
        role,
        collection,
      )
    }
  },
  addAuthor: async (collection, user, res, url) => {
    if (collection.owners.includes(user.id)) {
      return res.status(200).json(user)
    }
    try {
      await mailService.setupAssignEmail(user.email, 'assign-author', url)

      return res.status(200).json(user)
    } catch (e) {
      logger.error(e)
      return res.status(500).json({ error: 'Email could not be sent.' })
    }
  },
}
