const uuid = require('uuid')

const getInvitationData = (invitations, userId, role) => {
  const matchingInvitation = invitations.find(
    inv => inv.role === role && inv.userId === userId,
  )
  let status = 'pending'
  if (matchingInvitation.isAccepted) {
    status = 'accepted'
  } else if (matchingInvitation.hasAnswer) {
    status = 'refused'
  }

  const { timestamp } = matchingInvitation
  return { timestamp, status }
}

const setupInvitation = async (userId, role, collection) => {
  const invitation = {
    role,
    hasAnswer: false,
    isAccepted: false,
    timestamp: Date.now(),
    id: uuid.v4(),
    userId,
  }
  collection.invitations = collection.invitations || []
  collection.invitations.push(invitation)
  collection = await collection.save()
  return collection
}

module.exports = {
  getInvitationData,
  setupInvitation,
}
